// Copyright (c) 2024 Codemongous LLC. All Rights Reserved.

#pragma once
#include "ISCW_UObject.h"

#include <memory>
#include <string>
#include <vector>

using std::shared_ptr;
using std::wstring;
using std::vector;

namespace Sourcify
{
	class ISCW_UScriptStruct;
	class ISCW_UDataTable : public virtual ISCW_UObject
	{
	public:
		virtual ~ISCW_UDataTable() = default;
		
		virtual shared_ptr<ISCW_UDataTable> ToUDataTablePtr() = 0;
		virtual shared_ptr<const ISCW_UDataTable> ToUDataTablePtr() const = 0;

		virtual vector<wstring> CreateTableFromCSVString(const wstring& csvString) = 0;

		virtual void EmptyTable() = 0;

		virtual wstring GetTableAsCSV() const = 0;

		virtual shared_ptr<ISCW_UScriptStruct> GetRowStruct() const = 0;

		virtual void SetRowStruct(shared_ptr<ISCW_UScriptStruct> rowStruct) = 0;

		virtual void HandleDataTableChanged() = 0;
	};

	using ISCW_UDataTableConstPtr = shared_ptr<const ISCW_UDataTable>;
	using ISCW_UDataTablePtr = shared_ptr<ISCW_UDataTable>;
} // namespace Sourcify